searchNodes=[{"doc":"An interval represents the points between two endpoints. The interval can be empty. The empty interval is never contained in any other interval, and contains itself no points. It can also be left and/or right unbounded, in which case it contains all points in the unbounded direction. A fully unbounded interval contains all other intervals, except the empty interval.","ref":"Interval.html","title":"Interval","type":"module"},{"doc":"Is the interval a adjacent to b , to the left of b . a is adjacent to b left of b , if a and b do not overlap, and there are no points between a.right and b.left . a : [ -- - ) b : [ -- - ) r : true a : [ -- - ] b : [ -- - ] r : false ( overlaps ) a : ( -- - ) b : ( -- - ) r : false ( points exist between a . right and b . left ) Examples iex&gt; adjacent_left_of? ( new ( left : 1 , right : 2 ) , new ( left : 2 , right : 3 ) ) true iex&gt; adjacent_left_of? ( new ( left : 1 , right : 3 ) , new ( left : 2 , right : 4 ) ) false iex&gt; adjacent_left_of? ( new ( left : 3 , right : 4 ) , new ( left : 1 , right : 2 ) ) false iex&gt; adjacent_left_of? ( new ( right : 2 , bounds : &quot;[]&quot; ) , new ( left : 3 ) ) true","ref":"Interval.html#adjacent_left_of?/2","title":"Interval.adjacent_left_of?/2","type":"function"},{"doc":"Is the interval a adjacent to b , to the right of b . a is adjacent to b right of b , if a and b do not overlap, and there are no points between a.left and b.right . a : [ -- - ) b : [ -- - ) r : true a : [ -- - ) b : [ -- - ] r : false ( overlaps ) a : ( -- - ) b : ( -- - ) r : false ( points exist between a . left and b . right ) Examples iex&gt; adjacent_right_of? ( new ( left : 2 , right : 3 ) , new ( left : 1 , right : 2 ) ) true iex&gt; adjacent_right_of? ( new ( left : 1 , right : 3 ) , new ( left : 2 , right : 4 ) ) false iex&gt; adjacent_right_of? ( new ( left : 1 , right : 2 ) , new ( left : 3 , right : 4 ) ) false iex&gt; adjacent_right_of? ( new ( left : 3 ) , new ( right : 2 , bounds : &quot;]&quot; ) ) true","ref":"Interval.html#adjacent_right_of?/2","title":"Interval.adjacent_right_of?/2","type":"function"},{"doc":"Does a contain b ? a contains b of all points in b is also in a . For an interval a to contain an interval b , all points in b must be contained in a : a : [ -- -- -- - ] b : [ -- - ] r : true a : [ -- - ] b : [ -- - ] r : true a : [ -- - ] b : ( -- - ) r : true a : ( -- - ) b : [ -- - ] r : false a : [ -- - ] b : [ -- -- -- - ] r : false This means that a.left is less than b.left (or unbounded), and a.right is greater than b.right (or unbounded) If a and b 's point match, then b is &quot;in&quot; a if a and b share bound types. E.g. if a.left and b.left matches, then a contains b if both a and b 's left is inclusive or exclusive. If either of b endpoints are unbounded, then a only contains b if the corresponding endpoint in a is also unbounded. Examples iex&gt; contains? ( new ( left : 1 , right : 2 ) , new ( left : 1 , right : 2 ) ) true iex&gt; contains? ( new ( left : 1 , right : 3 ) , new ( left : 2 , right : 3 ) ) true iex&gt; contains? ( new ( left : 2 , right : 3 ) , new ( left : 1 , right : 4 ) ) false iex&gt; contains? ( new ( left : 1 , right : 3 ) , new ( left : 1 , right : 2 ) ) true iex&gt; contains? ( new ( left : 1 , right : 2 , bounds : &quot;()&quot; ) , new ( left : 1 , right : 3 ) ) false iex&gt; contains? ( new ( right : 1 ) , new ( left : 0 , right : 1 ) ) true","ref":"Interval.html#contains?/2","title":"Interval.contains?/2","type":"function"},{"doc":"Is the interval empty? An empty interval is an interval that represents no points. Any interval interval containing no points is considered empty. Examples iex&gt; empty? ( new ( left : 0 , right : 0 ) ) true iex&gt; empty? ( single ( 1.0 ) ) false iex&gt; empty? ( new ( left : 1 , right : 2 ) ) false","ref":"Interval.html#empty?/1","title":"Interval.empty?/1","type":"function"},{"doc":"","ref":"Interval.html#from_endpoints/2","title":"Interval.from_endpoints/2","type":"function"},{"doc":"Compute the intersection between a and b . The intersection contains all of the points that are both in a and b . If either a or b are empty, the returned interval will be empty. a : [ -- -- ] b : [ -- -- ] r : [ - ] a : ( -- -- ) b : ( -- -- ) r : ( - ) a : [ -- -- ) b : [ -- -- ) r : [ - ) Examples: Discrete: a : [ -- -- ) b : [ -- -- ) c : [ - ) iex&gt; intersection ( new ( left : 1 , right : 3 ) , new ( left : 2 , right : 4 ) ) new ( left : 2 , right : 3 ) Continuous: a : [ -- -- ) b : [ -- -- ) c : [ - ) iex&gt; intersection ( new ( left : 1.0 , right : 3.0 ) , new ( left : 2.0 , right : 4.0 ) ) new ( left : 2.0 , right : 3.0 ) a : ( -- -- ) b : ( -- -- ) c : ( - ) iex&gt; intersection ( ...&gt; new ( left : 1.0 , right : 3.0 , bounds : &quot;()&quot; ) , ...&gt; new ( left : 2.0 , right : 4.0 , bounds : &quot;()&quot; ) ...&gt; ) new ( left : 2.0 , right : 3.0 , bounds : &quot;()&quot; )","ref":"Interval.html#intersection/2","title":"Interval.intersection/2","type":"function"},{"doc":"Is the interval left-inclusive? The interval is left-inclusive if the left endpoint value is included in the interval. NOTE: Discrete intervals (like integers and dates) are always normalized to be left-inclusive right-exclusive ( [) ) which this function reflects. iex&gt; left_inclusive? ( new ( left : 1.0 , right : 2.0 , bounds : &quot;[]&quot; ) ) true iex&gt; left_inclusive? ( new ( left : 1.0 , right : 2.0 , bounds : &quot;[)&quot; ) ) true iex&gt; left_inclusive? ( new ( left : 1.0 , right : 2.0 , bounds : &quot;()&quot; ) ) false","ref":"Interval.html#left_inclusive?/1","title":"Interval.left_inclusive?/1","type":"function"},{"doc":"Check if the interval is left-unbounded. The interval is left-unbounded if all points left of the right bound is included in this interval. Examples iex&gt; left_unbounded? ( new ( ) ) true iex&gt; left_unbounded? ( new ( right : 2 ) ) true iex&gt; left_unbounded? ( new ( left : 1 , right : 2 ) ) false","ref":"Interval.html#left_unbounded?/1","title":"Interval.left_unbounded?/1","type":"function"},{"doc":"Create a new unbounded interval","ref":"Interval.html#new/1","title":"Interval.new/1","type":"function"},{"doc":"Normalize an Interval struct","ref":"Interval.html#normalize/1","title":"Interval.normalize/1","type":"function"},{"doc":"Does a overlap with b ? a overlaps with b if any point in a is also in b . a : [ -- - ) b : [ -- - ) r : true a : [ -- - ) b : [ -- - ) r : false a : [ -- - ] b : [ -- - ] r : true a : ( -- - ) b : ( -- - ) r : false a : [ -- - ) b : [ -- - ) r : false Examples [ -- a -- ) [ -- b -- ) iex&gt; overlaps? ( new ( left : 1 , right : 3 ) , new ( left : 2 , right : 4 ) ) true [ -- a -- ) [ -- b -- ) iex&gt; overlaps? ( new ( left : 1 , right : 3 ) , new ( left : 3 , right : 5 ) ) false [ -- a -- ] [ -- b -- ] iex&gt; overlaps? ( new ( left : 1 , right : 3 ) , new ( left : 2 , right : 4 ) ) true ( -- a -- ) ( -- b -- ) iex&gt; overlaps? ( new ( left : 1 , right : 3 ) , new ( left : 3 , right : 5 ) ) false [ -- a -- ) [ -- b -- ) iex&gt; overlaps? ( new ( left : 1 , right : 2 ) , new ( left : 3 , right : 4 ) ) false","ref":"Interval.html#overlaps?/2","title":"Interval.overlaps?/2","type":"function"},{"doc":"Is the interval right-inclusive? The interval is right-inclusive if the right endpoint value is included in the interval. NOTE: Discrete intervals (like integers and dates) are always normalized to be left-inclusive right-exclusive ( [) ) which this function reflects. iex&gt; right_inclusive? ( new ( left : 1.0 , right : 2.0 , bounds : &quot;[]&quot; ) ) true iex&gt; right_inclusive? ( new ( left : 1.0 , right : 2.0 , bounds : &quot;[)&quot; ) ) false iex&gt; right_inclusive? ( new ( left : 1.0 , right : 2.0 , bounds : &quot;()&quot; ) ) false","ref":"Interval.html#right_inclusive?/1","title":"Interval.right_inclusive?/1","type":"function"},{"doc":"Check if the interval is right-unbounded. The interval is right-unbounded if all points right of the left bound is included in this interval. Examples iex&gt; right_unbounded? ( new ( right : 1 ) ) false iex&gt; right_unbounded? ( new ( ) ) true iex&gt; right_unbounded? ( new ( left : 1 ) ) true","ref":"Interval.html#right_unbounded?/1","title":"Interval.right_unbounded?/1","type":"function"},{"doc":"Create a new Interval containing a single point.","ref":"Interval.html#single/1","title":"Interval.single/1","type":"function"},{"doc":"Is a strictly left of b . a is strictly left of b if no point in a is in b , and all points in a is left (&lt;) of all points in b . Examples a : [ -- - ) b : [ -- - ) r : true a : [ -- - ) b : [ -- - ) r : true a : [ -- - ) b : [ -- - ) r : false ( overlaps ) iex&gt; strictly_left_of? ( new ( left : 1 , right : 2 ) , new ( left : 3 , right : 4 ) ) true iex&gt; strictly_left_of? ( new ( left : 1 , right : 3 ) , new ( left : 2 , right : 4 ) ) false iex&gt; strictly_left_of? ( new ( left : 3 , right : 4 ) , new ( left : 1 , right : 2 ) ) false","ref":"Interval.html#strictly_left_of?/2","title":"Interval.strictly_left_of?/2","type":"function"},{"doc":"Is a strictly right of b . a is strictly right of b if no point in a is in b , and all points in a is right (&gt;) of all points in b . Examples a : [ -- - ) b : [ -- - ) r : true a : [ -- - ) b : [ -- - ) r : true a : [ -- - ) b : [ -- - ) r : false ( overlaps ) iex&gt; strictly_right_of? ( new ( left : 1 , right : 2 ) , new ( left : 3 , right : 4 ) ) false iex&gt; strictly_right_of? ( new ( left : 1 , right : 3 ) , new ( left : 2 , right : 4 ) ) false iex&gt; strictly_right_of? ( new ( left : 3 , right : 4 ) , new ( left : 1 , right : 2 ) ) true","ref":"Interval.html#strictly_right_of?/2","title":"Interval.strictly_right_of?/2","type":"function"},{"doc":"Computes the union of a and b . The union contains all of the points that are either in a or b . If either a or b are empty, the returned interval will be empty. a : [ -- - ) b : [ -- - ) r : [ -- -- - ) Examples [ -- A -- ) [ -- B -- ) [ -- -- C -- -- ) iex&gt; union ( new ( left : 1 , right : 3 ) , new ( left : 2 , right : 4 ) ) new ( left : 1 , right : 4 ) [ - A - ) [ - B - ) [ -- - C -- - ) iex&gt; union ( new ( left : 1 , right : 2 ) , new ( left : 2 , right : 3 ) ) new ( left : 1 , right : 3 ) iex&gt; union ( new ( left : 1 , right : 2 ) , new ( left : 3 , right : 4 ) ) new ( left : 0 , right : 0 )","ref":"Interval.html#union/2","title":"Interval.union/2","type":"function"},{"doc":"The Interval struct, representing all points between two endpoints. The struct has two fields: left and right , representing the left (lower) and right (upper) points in the interval. The endpoints are stored as an Interval.Endpoint.t/0 or the atom :unbounded . A special case exists for the empty interval, which is represented by both left and right being set to the atom :empty","ref":"Interval.html#t:t/0","title":"Interval.t/0","type":"type"},{"doc":"An endpoint in an Interval . An Endpoint represents the left- or right-most point of an interval.","ref":"Interval.Endpoint.html","title":"Interval.Endpoint","type":"module"},{"doc":"Create a new exclusive Endpoint.","ref":"Interval.Endpoint.html#exclusive/1","title":"Interval.Endpoint.exclusive/1","type":"function"},{"doc":"Create a new inclusive Endpoint.","ref":"Interval.Endpoint.html#inclusive/1","title":"Interval.Endpoint.inclusive/1","type":"function"},{"doc":"","ref":"Interval.Endpoint.html#inclusive?/1","title":"Interval.Endpoint.inclusive?/1","type":"function"},{"doc":"Create a new Endpoint","ref":"Interval.Endpoint.html#new/2","title":"Interval.Endpoint.new/2","type":"function"},{"doc":"","ref":"Interval.Endpoint.html#point_impl_for/1","title":"Interval.Endpoint.point_impl_for/1","type":"function"},{"doc":"","ref":"Interval.Endpoint.html#t:t/0","title":"Interval.Endpoint.t/0","type":"type"},{"doc":"The Interval.Point protocol defines a set of functions the Interval module needs to use a value as a point in an interval. Implementing this protocol for a type allows you to use that type as a point in the Interval type. Point Types Interval accepts two kinds of point types: Discrete Continuous Discrete A discrete point type is one where the number of points in a bounded interval is finite and knowable. Every discrete point has a concept of the next/1 and previous/1 point (in contrast to something like a real number where there exists an infinite number of points between two other points) Continuous The continuous point type is for points where there exists (at least conceptually) an infinite number of points between two other points. Examples of this are floats, points in time, etc. These points have no useful notion of the &quot;next&quot; and &quot;previous&quot; point, and implements these functions as raising an error. Default Implementations This library ships with implementations for Date (discrete) Integer (discrete) DateTime (continuous) Float (continuous) If you wish to implement the Interval.Point protocol for one of these types yourself, you can disable the built-in implementation by setting the module to false under the :interval OTP application: import Config config :interval , Date , false","ref":"Interval.Point.html","title":"Interval.Point","type":"protocol"},{"doc":"Compare two interval points (of the same time) and returns if a is less than equal greater than b","ref":"Interval.Point.html#compare/2","title":"Interval.Point.compare/2","type":"function"},{"doc":"Return the largest (right-most) of the two points.","ref":"Interval.Point.html#max/2","title":"Interval.Point.max/2","type":"function"},{"doc":"Return the smallest (left-most) of the two points.","ref":"Interval.Point.html#min/2","title":"Interval.Point.min/2","type":"function"},{"doc":"Given a point A, return the next value after A. If the point type is continuous then this error must raise an error","ref":"Interval.Point.html#next/1","title":"Interval.Point.next/1","type":"function"},{"doc":"Given a point A, return the previous value after A. If the point type is continuous then this error must raise an error","ref":"Interval.Point.html#previous/1","title":"Interval.Point.previous/1","type":"function"},{"doc":"Returns if the Point lies on a discrete (like integer) or a continuous line (like floats). If the value given is not a valid Point, then this function must return :invalid","ref":"Interval.Point.html#type/1","title":"Interval.Point.type/1","type":"function"},{"doc":"","ref":"Interval.Point.html#t:t/0","title":"Interval.Point.t/0","type":"type"},{"doc":"docs: https://hexdocs.pm/interval inspired by PostgreSQL's range types","ref":"readme.html","title":"Interval","type":"extras"},{"doc":"The package can be installed by adding interval to your list of dependencies in mix.exs : def deps do [ { :interval , &quot;~&gt; 0.1.0&quot; } ] end","ref":"readme.html#installation","title":"Interval - Installation","type":"extras"},{"doc":"Interval Empty Bounds","ref":"readme.html#concept","title":"Interval - Concept","type":"extras"},{"doc":"Integer intervals a = Interval . new ( left : 1 , right : 4 , bounds : &quot;[]&quot; ) b = Interval . new ( left : 2 , right : 5 , bounds : &quot;[]&quot; ) assert Interval . contains? ( a , b ) assert Interval . overlaps? ( a , b ) c = Interval . intersection ( a , b ) # [2, 4] d = Interval . union ( a , b ) # [1, 5] DateTime intervals # default bound is &quot;[)&quot; y2022 = Interval . new ( left : ~U[2022-01-01 00:00:00Z] , right : ~U[2023-01-01 00:00:00Z] ) x = Interval . new ( left : ~U[2018-07-01 00:00:00Z] , right : ~U[2022-03-01 00:00:00Z] ) Interval . intersection ( y2022 , x ) # %Interval{ # left: %Interval.Endpoint{inclusive: true, point: ~U[2022-01-01 00:00:00Z]}, # right: %Interval.Endpoint{inclusive: false, point: ~U[2022-03-01 00:00:00Z]} # }","ref":"readme.html#examples","title":"Interval - Examples","type":"extras"}]